package Davis::Console;

use strict;

use Davis::WeatherLink;

sub new
{
   my $type = shift;

   my $self = bless { @_ };
   bless $self, $type;

   $self->{baud} ||= 2400;
   die "Invalid baud rate: " . $self->{baud}
	unless ($self->{baud} == 1200 || $self->{baud} == 2400);

   $self->{device} ||= '/dev/davis';

   $self->{link} = new Davis::WeatherLink(
	port => $self->{port},
	baud => $self->{baud},
	);

   return undef unless $self->{link};

   return undef unless $self->{link}->start;

   return $self;
}


sub loop
{
   warn "loop method must be overridden!!!";
   return undef;
}


1;

