
drop table forecast_rules;

create table forecast_rules (
	wind_min	number(5,2),
	wind_max	number(5,2),
	bar_min		number(4),
	bar_max		number(4),
	delta_bar_min	number(2,1),
	delta_bar_max	number(2,1),
	forecast	varchar2(200)
	)
;

insert into forecast_rules values ( 112.5, 202.5, 1019, 1023, -3, -0.5, 'rain in 24 hours');
insert into forecast_rules values ( 112.5, 202.5, 1019, 1023, null, -3, 'rain in 12-24 hours, high wind');
insert into forecast_rules values ( 22.5, 157.5, 1019, 1023, -3, -0.5, 'increasing wind, rain in 12-18 hours');
insert into forecast_rules values ( 22.5, 157.5, 1019, 1023, null, -3, 'increasing wind, rain in 12 hours or less');
insert into forecast_rules values ( 22.5, 157.5, null, 1016, -3, -0.5, 'rain continuing for 1-3 days');
insert into forecast_rules values ( 22.5, 157.5, null, 1016, null, -3, 'rain and high wind in 1-6 hours, clearing in 36 hours, colder');
insert into forecast_rules values ( 22.5, 112.5, 1019, null, -3, -0.5, 'summer: light wind/rain in 1-3 days, winter: rain/wind in 24 hours');
insert into forecast_rules values ( 22.5, 112.5, 1019, null, null, -3, 'summer: rain/wind in 12-24 hours, winter: rain, snow/wind in 12 hours');
insert into forecast_rules values ( 337.5, 202.5, null, 1009, null, -3, 'severe storm in few hours, clear in 24 hours');
insert into forecast_rules values ( 202.5, 337.5, null, 1009, 3, null, 'high winds up to 24 hours, cold, thunderstorms, showers, then clearing');
insert into forecast_rules values ( 202.5, 337.5, 1019, 1023, -0.5, 0.5, 'little change next 1-2 days');
insert into forecast_rules values ( 202.5, 337.5, 1019, 1023, 3, null, 'fair, possible rain in 2 days');
insert into forecast_rules values ( 202.5, 337.5, 1023, null, -3, 0.5, 'continued fair');

commit;

-- test for wind=5, bar=1008, delta_bar=-4

select forecast
from forecast_rules
where
	(
		( wind_min < wind_max and 5 between wind_min and wind_max )
		or ( wind_min > wind_max and ( wind_min <= 5 or 5 <= wind_max ) )
	)
	and (
		( bar_min is not null and bar_max is not null and 1008 between bar_min and bar_max )
		or ( bar_min is null and 1008 <= bar_max )
		or ( bar_max is null and bar_min <= 1008 )
	)
	and (
		( delta_bar_min is not null and delta_bar_max is not null and -4 between delta_bar_min and delta_bar_max )
		-- or ( delta_bar_min is null and delta_bar_max is null )
		or ( delta_bar_min is null and -4 <= delta_bar_max )
		or ( delta_bar_max is null and delta_bar_min <= -4 )
	)
;




