#!/usr/local/bin/perl

use strict;

use Davis::Derived;
use Davis::WeatherLink;

my $wl = new Davis::WeatherLink;

my @datetime = localtime;

# avoid rollover while time is being set
while ($datetime[0] >= 55)
{
   sleep 10;
   @datetime = localtime;
}

my (
	$sec,
	$min,
	$hr,
	$mday,
	$mon,
	$year,
	$wday,
	$yday,
	$isdst,
	) = @datetime;

$mon++;
$year += 1900;

my $timeblock = pack("CCC", to_bcd($hr), to_bcd($min), to_bcd($sec));
my $dateblock = pack("CC", to_bcd($mday), $mon);

$wl->write_station_memory(1, 0xbe, 6, $timeblock);
$wl->write_station_memory(1, 0xc8, 3, $dateblock);

exit;



