#!/usr/local/bin/perl

use Data::Dumper;

use strict;

use Davis::Derived;
use Davis::VantagePro;

$|=1;

my $obj = new Davis::VantagePro;

$obj->wakeup || die "Wakeup failed";
$obj->test || die "Test failed";
$obj->wrd;	# just makes sure it's a VP
$obj->start;

my $data = $obj->loop;
my $rxdata = $obj->rxcheck;
my $datetime = $obj->gettime;

printf qq{

 Next Record: %s

        Time: %s/%s/%s %2s:%02s:%02s

   Barometer: %s" or %.1f mbars

 Inside Temp: %4.1f deg    Hum: %2s%%
Outside Temp: %4.1f deg    Hum: %2s%%    Dew Pt: %.0f deg

   Rain Rate: %5.2f in/hr
       Storm: %5.2f in
         Day: %5.2f in
       Month: %5.2f in
        Year: %5.2f in

Forecast Icons: %s
 Forecast Rule: %s

Received Packets: %s
Best Good Streak: %s
  Missed Packets: %s
      CRC Errors: %s
            Unk2: %s

},
	$data->{next_record},
	$datetime->{year}, $datetime->{month}, $datetime->{day},
	$datetime->{hour}, $datetime->{minute}, $datetime->{second},
	$data->{barometer}, mbars($data->{barometer}),
	$data->{inside_temp},
	$data->{inside_hum},
	$data->{outside_temp},
	$data->{outside_hum},
	dew_point($data->{outside_temp}, $data->{outside_hum}),
	$data->{rain_rate},
	$data->{rain_storm},
	$data->{rain_day},
	$data->{rain_month},
	$data->{rain_year},
	$data->{forecast_icons},
	$data->{forecast_rule},
	$rxdata->{received_packets},
	$rxdata->{longest_good_streak},
	$rxdata->{missed_packets},
	$rxdata->{crc_errors},
	$rxdata->{unk2},
	;

exit;


