#!/usr/local/bin/perl

use Data::Dumper;

use strict;

use lib '..';
use Davis::Derived;
use Davis::VantagePro;

$|=1;

my $station = new Davis::VantagePro;

die "Couldn't connect to weather station" unless $station;

my $loop = $station->loop;
my $rxcheck = $station->rxcheck;

printf qq{
<html>
<head>
<title>Current Weather Conditions</title>
</head>
<body>

<table>
<tr><th colspan=2>%s</th></tr>
<tr><td>Temperature</td><td>%.1f&deg;F</td></tr>
<tr><td>Barometer</td><td>%.3f" Hg / %.1f mbar</td></tr>
<tr><td>Relative Humidity</td><td>%.0f%%</td></tr>
<tr><td>Dew Point</td><td>%.0f&deg;F</td></tr>
<tr><td>Rain Rate</td><td>%.2f"/hr</td></tr>
<tr><td>Daily Rain</td><td>%.2f"</td></tr>
<tr><td>Monthly Rain</td><td>%.2f"</td></tr>
<tr><td>Yearly Rain</td><td>%.2f"</td></tr>
<tr><td>12-24 Hr Forecast</td><td>%s</td></tr>
</table>

</body>
</html>
},
	localtime(time) . "",
	$loop->{outside_temp},
	$loop->{barometer}, mbars($loop->{barometer}),
	$loop->{outside_hum},
	dew_point($loop->{outside_temp}, $loop->{outside_hum}),
	$loop->{rain_rate},
	$loop->{rain_day},
	$loop->{rain_month},
	$loop->{rain_year},
	$loop->{forecast_icons},
	;

exit;


