#!/usr/local/bin/perl

use CGI;
use Chart::GnuPlot;
use Image::Magick;
use DBI;
use Data::Dumper;
use Date::Manip;

use strict;

use Davis::Derived;

REQUEST:
foreach my $q (new CGI)
{

   if ($ENV{REQUEST_METHOD} eq 'HEAD')
   {
      print STDERR "Just a HEAD request...\n";
      print $q->header;
      next REQUEST;
   }

   &Date_Init("TZ=CDT");
   $ENV{DEBUG} = 0;
   $ENV{ORACLE_HOME} = '/home/oracle/app/oracle/product/8.0.5';

   my $dbh = DBI->connect('dbi:Oracle:MISC', 'weather', 'ycgsfn');

   my $historical = $dbh->selectall_arrayref("
        select
		to_char(trunc(timestamp), 'mm/dd/yyyy'),
		nvl(avg(nvl(wind_speed, 0)), 0),
		nvl(max(wind_speed), 0),
		nvl(max(wind_gust), 0)
        from weather_log
	where timestamp >= sysdate - :1 + 1
	-- where timestamp >= ( select min(timestamp) from weather_log where wind_speed is not null )
        group by trunc(timestamp)
        order by trunc(timestamp)
        ", undef, $q->param('days') || 365);

   my $gp = Chart::GnuPlot->new();

   # common settings here
   my $params = {
		terminal => 'gif',
		size => '640,300',
		timefmt => '%m/%d/%Y-%H:%M',
		grid => 1,
		key => 'top left',
		colours => { series => ['0000ff', 'ff0000', 'ff8000', '00ff40'], },
		xformat => "%a\\n%m/%d\\n%H:%M",

		title => 'Historical Daily Wind Avg/Max/Gust',
		timefmt => '%m/%d/%Y',
		xformat => "%a\\n%m/%d",
		data => [ $historical, ],
		colours => { series => ['ff0000', '00aa88', '0000ff'], },
		plots => [
			{ columns => [1, 4], type => 'lines', title => 'Max Gust' },
			{ columns => [1, 3], type => 'lines', title => 'Max Sust' },
			{ columns => [1, 2], type => 'lines', title => 'Avg' },
			],
	};

   my ($image, $ext) = $gp->plot($params);

   print $q->header(
	-type => "image/$ext",
	-expires => "+15m",
	);
   print $image;

}





